'use strict';
var objectPatternA = require('nodes');
var nodes = objectPatternA.nodes;
var objectPattern = require('../util/self');
var getSelfId = objectPattern.getSelfId;
function arrowify(program) {
  program.search('#ArrowFunctionExpression => #ThisExpression').forEach(function (thisExpression) {
    var arrowFunction = thisExpression.scope();
    var arrowScope = arrowFunction.scope('[type!=ArrowFunctionExpression]');
    var selfId = getSelfId(arrowScope).clone();
    thisExpression.parentNode.replaceChild(thisExpression, selfId.clone());
  });
  program.search('#ArrowFunctionExpression').forEach(function (node) {
    var shallow = new nodes.FunctionExpression(node);
    node.parentNode.replaceChild(node, shallow);
  });
}
exports.transform = arrowify;