'use strict';
var objectPattern = require('nodes');
var objectPatternLists = objectPattern.lists;
var List = objectPatternLists.List;
var listIndex = function (node) {
  var lastNode = node, firstList;
  while (node = node.parentNode) {
    if (node instanceof List) {
      firstList = node;
      break;
    } else {
      lastNode = node;
    }
  }
  if (!firstList) {
    throw new Error('parent list not found');
  }
  return {
    list: firstList,
    index: firstList.indexOf(lastNode)
  };
};
exports.insertBefore = function (node, node2) {
  var li = listIndex(node);
  li.list.splice(li.index, 0, node2);
};
exports.insertAfter = function (node, node2) {
  var li = listIndex(node);
  li.list.splice(li.index + 1, 0, node2);
};